%LoopOptionsRS	Generate Ruge-Stueben options struct array for RunTests
%
%usage : options=LoopOptions([I])
%
%I : Index set denoting the subset of options to return, default is all options
%
%See also  LoopOptions LoopOptionsEig LoopOptionsBig RunTests


function options=LoopOptions(i)

nr=1;
options={};

opt.levsmax=0;
opt.mincoarse=100;
opt.pre=[];
opt.post=[];
opt.CF=[];
opt.P=[];
opt.R=[];

% Pre-Smoother
opt.pre.its=2;
opt.pre.type='Gauss-Seidel CF';

% Post-Smoother
opt.post.its=2;
opt.post.pre=1;

% Interpolation
for method          = {'R-S'}
opt.P.method=method{:};

% Coarse grid selection
opt.CF.direction    = 'row';   % 'row', 'row and column'
opt.CF.check_F_F    = 1;
opt.CF.theta        = 0.25;
for use_abs         = {0, 1};
opt.CF.use_abs=use_abs{:};
for use_diag        = {0};
opt.CF.use_diag=use_diag{:};
if ~(~opt.CF.use_abs & opt.CF.use_diag)
opt.CF.make_unconnected_F=0;

% Interpolation
opt.P.objective     = '-Aff\Afc';
if strcmp( opt.P.method, 'R-S')
  opt.P.pattern='';
  opt.P.matrix='A';
  opt.P.objective='-Aff\Afc';
  for weak            = {'lump', 'scale', 'trash'}
    opt.P.weak=weak{:};
%    for method64        = {'original', 'original abs', 'original abs abs'}
%      opt.P.method64=method64{:};
       opt.P.method64='original';
      if ~( ~opt.CF.use_abs & strncmp( opt.P.method64, 'original abs', 12 ) )

        % Restriction
        %opt.R.PT = 1;
        opt.R=opt.P;

        options{nr}=opt;
        nr=nr+1;
      end
%    end
  end
else
  error('Bug in LoopOptions');
end

end
end
end
end

options=[options{:}];
if nargin>0
  options=[options(i)];
end
